#include <applicat.h>
#include <mask.h>
#include <urldefid.h>

#include "velib01.h" 

#include "ve6000.h"

class TFatturazione_bolle_app : public TApplication
{ 
  TArray _file;
  void open_files(int logicnum, ...);

protected: // TApplication
  virtual bool create();
  virtual bool menu(MENU_TAG mt);

public:
  TFatturazione_bolle_app() { } 
  virtual ~TFatturazione_bolle_app() { }
};

void TFatturazione_bolle_app::open_files(int logicnum, ...)  
{  
  va_list marker;
  va_start(marker, logicnum);
  while (logicnum > 0)
  {
    CHECKD(_file.objptr(logicnum) == NULL, "File gia' aperto: ", logicnum);
    _file.add(new TLocalisamfile(logicnum), logicnum);
    logicnum = va_arg(marker, int);
  }
}


bool TFatturazione_bolle_app::create()
{
  open_files(LF_TABCOM, LF_CLIFO, LF_CFVEN, LF_DOC, LF_RIGHEDOC, 0);
  dispatch_e_menu(MENU_ITEM(1));
  return TRUE;
}

bool TFatturazione_bolle_app::menu(MENU_TAG)
{
  TMask m("ve6000");
  while (m.run() == K_ENTER)
  {                              
    begin_wait();
  
    const TDate data_elab = m.get(F_DATA_ELAB); 
    const int anno = data_elab.year();
    
    const long dc = m.get_long(F_CODICE_CLIFO_DA);
    const long ac = m.get_long(F_CODICE_CLIFO_A);
    const long da = m.get_long(F_CODICE_AGENTE_DA);
    const long aa = m.get_long(F_CODICE_AGENTE_A);
    const long dz = m.get_long(F_CODICE_ZONA_DA); 
    const long az = m.get_long(F_CODICE_ZONA_A);
    
    const TDate dd = m.get(F_DATA_DOCUMENTO_DA);
    const TDate ad = m.get(F_DATA_DOCUMENTO_A);
    const TString& codnum = m.get(F_CODICE_NUMERAZIONE);
    const long dn = m.get_long(F_NUMERO_DOCUMENTO_DA);
    const long an = m.get_long(F_NUMERO_DOCUMENTO_A);
    
    TFatturazione_bolle eld(m.get(F_CODICE_ELAB));
    
    TLista_clienti clienti;
    const int tot_cli = clienti.leggi(dc, ac, da, aa, dz, az);
    for (int c = 0; c < tot_cli; c++)
    {
      TLista_documenti din, dout;
      din.read('C', clienti[c], anno, dd, ad, codnum, dn, an);
      const bool ok = eld.elabora(din, dout, data_elab);
      if (ok) 
      {
        din.rewrite();
        dout.write();
      }
      else
      {
        error_box("I documenti relativi al cliente %ld non sono stati elaborati.",
                  clienti[c]);
        break;
      }  
    }
    end_wait();
  }
  return FALSE;
}

int ve6200 (int argc, char **argv)
{
  TFatturazione_bolle_app a;
  a.run (argc, argv, "Fatturazione Bolle");
  return TRUE;
}
